/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

using AdavSms;
using AdavSmsService;

namespace AdavSmsWebApplication
{
	/// <summary>
	/// Summary description for ViewLog.
	/// </summary>
	public class ViewLog : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label lblUsername;
		protected System.Web.UI.WebControls.DataGrid dgLog;
		protected System.Web.UI.WebControls.Label lblErrorMsg;
		protected System.Web.UI.WebControls.Button btnBack;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			// Put user code to initialize the page here
			if (!Page.IsPostBack)
			{
				string username = Request.Form["txtUsername"];
				string password = Request.Form["txtPassword"];
				if (username != null && password != null)
				{
					lblUsername.Text = username;

					IAdavSmsAdmin comp = AdavSmsService.Factory.CreateIAdavSmsAdminService();

					try
					{
						DataSet ds = comp.GetLogOfSentMessages(username, password);

						dgLog.DataSource = ds;
						dgLog.DataBind();
					}
					catch(ApplicationException ex)
					{
						lblErrorMsg.Text = ex.Message;
					}
				}
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.btnBack.Click += new System.EventHandler(this.btnBack_Click);
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

		private void btnBack_Click(object sender, System.EventArgs e)
		{
			Response.Redirect("Default.aspx", true);
		}
	}
}
