/*************************************************************

(C) ISEP 2004
(C) Professores de ADAV 2004

O ISEP, na qualidade de autor do presente software, garante 
o direito de utilizao, alterao, evoluo e distribuio 
do mesmo sem qualquer tipo de restries, excepto:
	- esta mensagem no pode ser retirada
	- os nomes das classes no podem ser alterados

*************************************************************/

using System;
using System.Data;
using System.Data.OleDb;

using AdavSms;
using Isep.Util;
using Isep.Util.Data;

namespace AdavSmsService
{
	/// <summary>
	/// Summary description for AdavSmsAdminImpl.
	/// </summary>
	internal class AdavSmsAdminImpl : IAdavSmsAdmin
	{
		public AdavSmsAdminImpl()
		{
			//
			// TODO: Add constructor logic here
			//
		}
	
		#region IAdavSmsAdmin Members

		public DataSet GetLogOfSentMessages(string user, string password)
		{
			//
			// validaes
			//
			if (user == null || user == string.Empty)
				throw new ArgumentException("cannot be null or empty", "user");
			if (password == null || password == string.Empty)
				throw new ArgumentException("cannot be null or empty", "password");

			//
			// processamento
			//
			OleDbConnection cnx = null;
			try
			{
				// abrir conexo
				cnx = OleDbHelper.CreateOpenConnection(AdavSmsService.Constants.CONN_STR);

				// verificar se utilizador existe e se est activo
				int userid = 0;
				try
				{
					userid = (int)OleDbHelper.ExecuteScalar(cnx, "SELECT id FROM Users WHERE user_name='" + user + "' AND pass_word='" + password + "' AND dateActivated <> NULL");
				}
				catch(NullReferenceException ex)
				{
					throw new ApplicationException("invalid username/password or account not activated", ex);
				}

				// executar query
				return OleDbHelper.ExecuteDataSet(cnx, "SELECT id, dateSent, destination, message, cost FROM SentMessages WHERE id_user = " + userid);
			}
			catch(OleDbException ex)
			{
				throw new ApplicationException("general database error in module AdavSmsAdminImpl.RegisterStepOne", ex);
			}
			catch(Exception ex)
			{
				throw;
			}
			finally
			{
				if (cnx != null && cnx.State == ConnectionState.Open)
					cnx.Close();
			}
		}

		public DataSet GetLogOfSentMessages(string user, string password, DateTime start, DateTime end)
		{
			// TODO:  Add AdavSmsAdminImpl.AdavSms.IAdavSmsAdmin.GetLogOfSentMessages implementation
			return null;
		}

		public void RegisterStepOne(string user, string password, string studentNumbers, string email)
		{
			//
			// validaes
			//
			if (user == null || user == string.Empty)
				throw new ArgumentException("cannot be null or empty", "user");
			if (password == null || password == string.Empty)
				throw new ArgumentException("cannot be null or empty", "password");
			if (studentNumbers == null || studentNumbers == string.Empty)
				throw new ArgumentException("cannot be null or empty", "studentNumbers");
			if (email == null || email == string.Empty)
				throw new ArgumentException("cannot be null or empty", "email");

			//
			// processamento
			//
			OleDbConnection cnx = null;
			OleDbTransaction tx = null;
			try
			{
				// abrir conexo & transaco
				tx = OleDbHelper.CreateTransactedConnection(AdavSmsService.Constants.CONN_STR);
				//ao fazer commit() ou Rollback() a propriedade Connection passa a null --> guardar valor
				cnx = tx.Connection; 

				//verificar se username j existe
				int n = (int)OleDbHelper.ExecuteScalar(tx, "SELECT count(*) FROM Users WHERE user_name='" + user + "'");
				if (n != 0)
					throw new ApplicationException("username already exists");
				
				// gerar chalange
				string chalenge = StringHelper.GenerateRandomString(AdavSmsService.Constants.CHALENGE_LEN);

				// registar - utilizador
				object[] parms = new object[] {
									"user_name",		OleDbType.Char,		user,
									"pass_word",		OleDbType.Char,		password,
									"email",			OleDbType.Char,		email,
									"studentNumbers",	OleDbType.Char,		studentNumbers,
									"dateCreated",		OleDbType.Date,		DateTime.Now,
									"id_rate",			OleDbType.Integer,	1,
									"dateActivated",	OleDbType.Date,		DBNull.Value,
								};
				OleDbHelper.ExecuteUpdate(tx, "INSERT INTO Users (user_name, pass_word, email, studentNumbers, dateCreated, id_rate, dateActivated) VALUES (?, ?, ?, ?, ?, ?, ?)", parms);
//				OleDbCommand cmd = new OleDbCommand("INSERT INTO Users (user_name, pass_word, email, studentNumbers, dateCreated, id_rate) VALUES (?, ?, ?, ?, ?, ?)", cnx);
//				cmd.Parameters.Add("user_name", user);
//				cmd.Parameters.Add("pass_word", password);
//				cmd.Parameters.Add("email", email);
//				cmd.Parameters.Add("studentNumbers", studentNumbers);
//				OleDbParameter p = cmd.Parameters.Add("dateCreated", OleDbType.Date); // parametros do tipo data tm que ser criados explicitamente 
//				p.Value = DateTime.Now;
//				cmd.Parameters.Add("id_rate", 1);
//				OleDbHelper.ExecuteUpdate(cnx, cmd, tx);


				// obter id autogerado
				int userid = (int)OleDbHelper.ExecuteScalar(tx, "SELECT @@IDENTITY");

				// registar - chalenge
				parms = new object[] {
									"id_user",	OleDbType.Char, userid,
									"chalenge", OleDbType.Char, chalenge
									};
				OleDbHelper.ExecuteUpdate(tx, "INSERT INTO Chalenges (id_user, chalenge) VALUES (?, ?)", parms);
//				cmd = new OleDbCommand("INSERT INTO Chalenges (id_user, chalenge) VALUES (?, ?)", cnx);
//				cmd.Parameters.Add("id_user", userid);
//				cmd.Parameters.Add("chalenge", chalenge);
//				OleDbHelper.ExecuteUpdate(cnx, cmd, tx);


				// enviar email
				string msgText = "User: " + user +
				"\n\nPlease activate your account at " + AdavSmsService.Constants.HOST + "AdavSmsWebApplication/Register3.aspx?chalenge=" + chalenge;
				System.Web.Mail.SmtpMail.SmtpServer = "localhost";
				System.Web.Mail.SmtpMail.Send("AdavSms-noreply@dei.isep.ipp.pt", email, "AdavSms - registration", msgText);

				// concluir transaco
				tx.Commit(); 
			}
			catch (OleDbException ex)
			{
				if (tx != null)
					tx.Rollback();
				throw new ApplicationException("general database error in module AdavSmsAdminImpl.RegisterStepOne", ex);
			}
			catch(Exception ex)
			{
				if (tx != null)
					tx.Rollback();
				throw new ApplicationException("general exception in module AdavSmsAdminImpl.RegisterStepOne", ex);
			}
			finally
			{
				if (cnx != null && cnx.State == ConnectionState.Open)
					cnx.Close();
			}
		}

		public bool RegisterStepTwo(string chalenge)
		{
			//
			// validaes
			//
			if (chalenge == null || chalenge == string.Empty)
				throw new ArgumentException("cannot be null or empty", "chalenge");

			//
			// processamento
			//
			OleDbConnection cnx = null;
			OleDbTransaction tx = null;
			try
			{
				// abrir conexo & transaco
				tx = OleDbHelper.CreateTransactedConnection(AdavSmsService.Constants.CONN_STR);
				//ao fazer commit() ou Rollback() a propriedade Connection passa a null --> guardar valor
				cnx = tx.Connection; 

				//verificar se chalenge existe
				DataSet ds = OleDbHelper.ExecuteDataSet(tx, "SELECT Chalenges.id, id_user, user_name, email, dateCreated FROM Chalenges, Users WHERE chalenge='" + chalenge + "' AND Users.id = Chalenges.id_user");
				if (ds.Tables[0].Rows.Count != 1)
					throw new ApplicationException("invalid chalenge");
				int chal_id = (int)ds.Tables[0].Rows[0][0];
				int user_id = (int)ds.Tables[0].Rows[0][1];
				string user = (string)ds.Tables[0].Rows[0][2];
				string email = (string)ds.Tables[0].Rows[0][3];
				DateTime dtCreated = (DateTime)ds.Tables[0].Rows[0][4];

				// verificar se token ainda  vlido
				if (DateTime.Now - dtCreated > new TimeSpan(3, 0, 0, 0))
					throw new ApplicationException("outdated token. please reregister");
				
				// gerar token
				string token = StringHelper.GenerateRandomString(AdavSmsService.Constants.TOKEN_LEN);

				// actualizar utilizador
				object[] parms = new object[] {
									"token",			OleDbType.Char,		token,
									"dateActivated",	OleDbType.Date,		DateTime.Now,
									"id",				OleDbType.Integer,	user_id
									};
				OleDbHelper.ExecuteUpdate(tx, "UPDATE Users SET token=?, dateActivated=? WHERE id=?", parms);
//				OleDbCommand cmd = new OleDbCommand("UPDATE Users SET token=?, dateActivated=? WHERE id=?", cnx);
//				cmd.Parameters.Add("token", token);
//				OleDbParameter p = cmd.Parameters.Add("dateActivated", OleDbType.Date); // parametros do tipo data tm que ser criados explicitamente 
//				p.Value = DateTime.Now;
//				cmd.Parameters.Add("id", user_id);

//				OleDbParameterCollection parms = new OleDbParameterCollection();
//				parms.Add("token", token);
//				OleDbParameter p = cmd.Parameters.Add("dateActivated", OleDbType.Date); // parametros do tipo data tm que ser criados explicitamente 
//				p.Value = DateTime.Now;
//				parms.Add("id", user_id);
//				OleDbHelper.ExecuteUpdate(cnx, "UPDATE Users SET token=?, dateActivated=? WHERE id=?", parms, tx);


				// apagar chalenge
				OleDbHelper.ExecuteUpdate(tx, "DELETE FROM Chalenges WHERE id=" + chal_id.ToString());
//				OleDbCommand cmd = new OleDbCommand("DELETE FROM Chalenges WHERE id=?", cnx);
//				cmd.Parameters.Add("id", chal_id);
//				OleDbHelper.ExecuteUpdate(cnx, cmd, tx);


				// enviar email
				string msgText = "User: " + user +
				"\n\ntoken:\n\n" + token +
				"\n\nPlease download:\n\n" +
				AdavSmsService.Constants.HOST + "AdavSmsWebApplication/files/AdavSms.zip\n" +
				"\n\n" +
				"How to use:\n\n" +
				"a) unpack the dlls in the zip file to your development directory" +
				"b) in your project add reference to the two downloaded components\n" +
				"c) use the compoennt according to thw following sample:\n\n\n" +
				"\t\tAdavSms.IAdavSms comp = AdavSmsClient.Factory.CreateIAdavSmsService();\n" +
				"\t\tfloat c = comp.Send(TOKEN, DESTINATION, MESSAGE);\n\n\n" +
				"where:\n" +
				"\tTOKEN is the license key at the top of this email message\n" +
				"\tDESTINATION is the number you which to send the sms to\n" +
				"\tMESSAGE is the text you want to send (masx. 255 characters)\n" +
				"\tthe method returns the COST of the call or a negative value in case of error (e.g., invalid token)" +
				"\n\nplease note that you need internet connectivity to use this component\n";

				System.Web.Mail.SmtpMail.SmtpServer = "localhost";
				System.Web.Mail.SmtpMail.Send("AdavSms-noreply@dei.isep.ipp.pt", email, "AdavSms - license", msgText);

				// concluir transaco
				tx.Commit();
			}
			catch (OleDbException ex)
			{
				if (tx != null)
					tx.Rollback();
				throw new ApplicationException("general database error in module AdavSmsAdminImpl.RegisterStepOne", ex);
			}
			catch(Exception ex)
			{
				if (tx != null)
					tx.Rollback();
				throw new ApplicationException("general exception in module AdavSmsAdminImpl.RegisterStepOne", ex);
			}
			finally
			{
				if (cnx != null && cnx.State == ConnectionState.Open)
					cnx.Close();
			}
			return true;
		}


		#endregion
	}
}
